//---------------------------------------------------------------------------
#ifndef HeadManH
#define HeadManH
//---------------------------------------------------------------------------
// various codes for field separators and incoming/outgoing codes
const AnsiString FieldSep = "\255";
const AnsiString InCode = "\250";
const AnsiString OutCode = "\251";
const AnsiString InReplySep = "\254";

//AnsiString __fastcall InMessageIndexString(char *msg);
const bool AddDummyReference = true;

class THeaderManager
{
private:
public:
   int Last;
   TStrings *Head;
   __fastcall THeaderManager(TStrings *Message=NULL);
   __fastcall ~THeaderManager();

   int __fastcall GetAttachments(TStrings *attachments,                   TStrings *Message=NULL);
   int __fastcall GetRecipients(TStrings *addresses,                      TStrings *Message=NULL);
   int __fastcall GetRecipsFull(AnsiString &Header, TStrings *addresses,  TStrings *Message=NULL);
   int __fastcall GetAddresses(TStrings *addresses, AnsiString &fromLine, TStrings *Message=NULL);
   int __fastcall GetFullAddresses(TStrings *addresses, AnsiString &fromLine, TStrings *Message=NULL);
   // getremaddresses gets addresses for type1.list descriptions
   int __fastcall GetRemAddresses(TStrings *addresses, AnsiString &fromLine, TStrings *Message=NULL);
   AnsiString __fastcall GetAddress(AnsiString &fromLine,                 TStrings *Message=NULL);
   AnsiString __fastcall GetDomain(AnsiString &fromAddress,               TStrings *Message=NULL);
   AnsiString __fastcall GetDom(AnsiString &fromAddress,                  TStrings *Message=NULL);
   AnsiString __fastcall GetDat(AnsiString &header,                       TStrings *Message=NULL);
   AnsiString __fastcall Get(AnsiString &header,                          TStrings *Message=NULL);
   AnsiString __fastcall GetDel(AnsiString &header,                       TStrings *Message=NULL);
   AnsiString __fastcall Get4Reply(AnsiString &header); // format for a reply message
   AnsiString __fastcall GetReferences(bool AddDummy=true); // reformats to a single line
   //AnsiString __fastcall GetConcatenatedHeader(AnsiString &header);
   AnsiString __fastcall GetNewsgroups(); // same here...
   AnsiString __fastcall GetFollowupTo();
   AnsiString __fastcall GetActualToDat(                                  TStrings *Message=NULL);

   AnsiString __fastcall IndexString(TStrings *Message, char Status='S');
   AnsiString __fastcall IndexStringNew(TStrings* Message=NULL);
   AnsiString __fastcall InIndexString(                                   TStrings *Message=NULL);
   AnsiString __fastcall InIndexStringShort(                              TStrings *Message=NULL);

   AnsiString __fastcall DateTimeOut(                                        TStrings *Message=NULL);
   AnsiString __fastcall DateTimeIn(                                        TStrings *Message=NULL);

   // utility functions
   int __fastcall IndexOf(AnsiString &header,                             TStrings *Message=NULL);
   int __fastcall Delete(AnsiString &header,                              TStrings *Message=NULL);
   bool __fastcall Has(AnsiString &header,                                TStrings *Message=NULL);
   void __fastcall HereIs(TStrings *Message);
   AnsiString __fastcall HdrName(const AnsiString Header);   // example "Fcc: "
   AnsiString __fastcall PopHeader();  //  return first header and delete it
   bool __fastcall IsMessage();
   long __fastcall Eoh();
};

typedef THeaderManager THeadMan;
typedef THeaderManager THeadManager;
//---------------------------------------------------------------------------
extern THeaderManager *HeadMan;
extern char Sortchar;
#endif
