#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "UPDFtpDlg.h"
#include "FileMan.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "Ftpcli"
#pragma resource "*.dfm"
TUPDftpDlg *UPDftpDlg;
#define TEMP_FILE_NAME "FTPDir.TXT"
//---------------------------------------------------------------------------
bool __fastcall GetQSUpdateList(TComponent *Owner, TStrings *Commands, TStrings *FileList)
{
   bool ok=false;
   FileList->Clear();
   UPDftpDlg = new TUPDftpDlg(Owner);
   UPDftpDlg->FTP->Port = Commands->Values["HostPort"];
   UPDftpDlg->FTP->HostDirName = Commands->Values["HostDir"];
   UPDftpDlg->FTP->HostName = Commands->Values["HostName"];
   UPDftpDlg->FTP->UserName = Commands->Values["UserName"];
   UPDftpDlg->FTP->PassWord = Commands->Values["Password"];
   UPDftpDlg->FTP->Passive = Commands->Values["Passive"]=="1";
   if (UPDftpDlg->GetUpdateList()==mrOk && FileExists(TEMP_FILE_NAME))
   {
      TStringList *tmp = new TStringList();
      UPDftpDlg->ParseFileList(tmp);
      FileList->Text = tmp->Text;
      delete tmp;
      ok = true;
   }
   if (FileExists(TEMP_FILE_NAME)) DeleteFile(TEMP_FILE_NAME);
   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GetQSUpdate(TComponent *Owner, TStrings *Commands)
{
   bool ok=false;
   AnsiString LocalFileName = Commands->Values["LocalFileName"];
   UPDftpDlg = new TUPDftpDlg(Owner);
   UPDftpDlg->FTP->Port = Commands->Values["HostPort"];
   UPDftpDlg->FTP->HostDirName = Commands->Values["HostDir"];
   UPDftpDlg->FTP->HostName = Commands->Values["HostName"];
   UPDftpDlg->FTP->UserName = Commands->Values["UserName"];
   UPDftpDlg->FTP->PassWord = Commands->Values["Password"];
   UPDftpDlg->FTP->Passive = Commands->Values["Passive"]=="1";
   UPDftpDlg->FTP->HostFileName = Commands->Values["HostFileName"];
   UPDftpDlg->FTP->LocalFileName = LocalFileName;
   UPDftpDlg->Filesize = Commands->Values["FileSize"].ToIntDef(0);
   if (UPDftpDlg->GetUpdate()==mrOk && FileExists(LocalFileName))
   {
      ok=true;
   }
   delete UPDftpDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUPDftpDlg::TUPDftpDlg(TComponent *Owner)
   : TForm(Owner)
{
   AnsiString host;
   CenterDialog(this,(TForm*)Owner);
   TimeOut->Interval = GetAppIni(UpdateWizTimeout,"").ToIntDef(30)*1000;
   FTP->PassWord = "nobody@nowhere.net";
   FTP->UserName = "anonymous";
   FTP->Port = "ftp";
   BytesTotal = 0;
   Cancel = false;
   Label1->Caption = "";
}
//---------------------------------------------------------------------------
int __fastcall TUPDftpDlg::GetUpdateList()
{
   Display->Clear();
   Display->Lines->Add("Connecting...");
   FTP->LocalFileName = TEMP_FILE_NAME;
   TimeOut->Enabled = true;
   FTP->DirectoryAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------
int __fastcall TUPDftpDlg::GetUpdate()
{
   Display->Clear();
   Display->Lines->Add("Connecting...");
   BytesTotal = Filesize;
   TimeOut->Enabled = true;
   FTP->ReceiveAsync();
   return ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::ParseFileList(TStringList *Results)
{
   Results->Clear();
   AnsiString name,date,size,entry,ext,tmp,fld;
   if (FileExists(TEMP_FILE_NAME))
   {
      TStringList *dir = new TStringList();
      dir->LoadFromFile(TEMP_FILE_NAME); DeleteFile(TEMP_FILE_NAME);
      for (int i=0; i<dir->Count; i++)
      {
         entry = dir->Strings[i];
         name = GetParam(8,entry," ");
         tmp = name.LowerCase();
         ext = ExtractFileExt(name).LowerCase();

         if (tmp.SubString(1,2)!="qs" && tmp.SubString(1,3)!="mix") continue;
         if (ext!=".exe" && ext!=".zip" && ext!=".txt") continue;

         for (int i=5; i<8; i++)
         {
            fld = GetParam(i,entry," ");
            if (i==6 && fld.Length()<2) fld = " "+fld;
            date = date+" "+fld;
         }
         size=GetParam(4,entry," ");
         while (size.Length()< 8) size = " "+size;
         while (name.Length()<11) name += " ";
         Results->Add(name+","+size+","+date);
         date = "";
      }
      delete dir;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPRequestDone(TObject *Sender, TFtpRequest RqType, WORD Error)
{
   AnsiString tmp,name;
   LastError = Error;
   if (Error)
   {
      FTPDisplay(Sender,"Error = " + IntToStr(Error) + " (" + FTP->ErrorMessage + ")");
      CancelBtn->Caption = "Close";
      TimeOut->Enabled = false;
      return;
   }
   switch (RqType)
   {
      case ftpListAsync:
      case ftpDirectoryAsync:
         if (Cancel || LastError)
         {
            if (FileExists(TEMP_FILE_NAME)) DeleteFile(TEMP_FILE_NAME);
            MyBeep(MB_ICONHAND);
            break;
         }
         TimeOut->Enabled = false;
         ModalResult = mrOk;
         Finished = true;
         break;
      case ftpReceiveAsync:
//ExploreFolder("updates");
         if (Cancel || LastError)
         {
            if (BytesReceived<BytesTotal && FileExists(FTP->LocalFileName))
            {
               Display->Lines->Add("Deleting "+ExtractFileName(FTP->LocalFileName)+"...");
               DeleteFile(FTP->LocalFileName.c_str());
            }
            MyBeep(MB_ICONHAND);
            break;
         }
         TimeOut->Enabled = false;
         ModalResult = mrOk;
         Finished = true;
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPDisplay(TObject *Sender, AnsiString &Msg)
{
   TimeOut->Enabled = false;
   if (!Cancel)
   {
      Display->Lines->Add(Msg);
      TimeOut->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPProgress(TObject *Sender, long Count, bool &Abort)
{
   TimeOut->Enabled = false;
   if (Cancel) Abort = true;
   if (!Abort && BytesTotal>0)
   {
      TimeOut->Enabled = true;
      Label1->Caption = AnsiString((int)Count)+" of "+AnsiString(BytesTotal)+" bytes ";
      ProgressBar1->Position = (Count/BytesTotal)*100;
      BytesReceived = Count;
   }
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::CancelBtnClick(TObject *Sender)
{
   FTP->Abort();
   TimeOut->Enabled = false;
   if (CancelBtn->Caption=="Cancel")
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Cancel = true;
      Sleep(1000);
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPSessionClosed(TObject *Sender, WORD Error)
{
   TimeOut->Enabled = false;
   /*LastError = Error;
   if (Cancel)
   {
      Display->Lines->Add("");
      Display->Lines->Add("User cancelled operation...");
      MyBeep(MB_ICONHAND);
      Sleep(1000);
      ModalResult = mrCancel;
   }*/
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::FTPSessionConnected(TObject *Sender, WORD Error)
{
   //Display->Lines->Add("Connected");
}
//---------------------------------------------------------------------------
void __fastcall TUPDftpDlg::TimeOutTimer(TObject *Sender)
{
   FTP->Abort();
   TimeOut->Enabled = false;
   Display->Lines->Add("");
   Display->Lines->Add("Operation timed out...");
   MsgBoxHwnd(Handle,
      s("The connection has timed out! Try again in a little while."),
      s("Time Out"),
      MB_OK
   );
   MyBeep(MB_ICONHAND);
   Cancel = true;
}
//---------------------------------------------------------------------------
